#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# pref: defines the layout and functions of the user preferences
#       dialog box.
proc pref {} {
  global LABELFONT prefDialogBox activeWindow SERVER_HOSTS XTERM \
	timeout_secs RSH

  busy_cursor
## Bring up the standard Dialog box ##
  set prefDialogBox ".pref"
  set dbox [popupDialogBox $prefDialogBox "User Preferences Dialog"]
  set activeWindow($prefDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]


## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.a
  frame $dbox_top.a.main
  set servers [buildFullEntrybox $dbox_top.a.main 17 \
                        "Server Hosts:" 30 "" "right" 0]
  set serversFrame [lindex $servers 0]
  set serversEntry [lindex $servers 2]
  $serversEntry configure -textvariable SERVER_HOSTS

  frame $dbox_top.a.xterm
  set xterm [buildFullEntrybox $dbox_top.a.xterm 17 \
                        "Xterm command" 30 "" "right" 0]
  set xtermFrame [lindex $xterm 0]
  set xtermEntry [lindex $xterm 2]
  $xtermEntry configure -textvariable XTERM

  frame $dbox_top.a.rsh
  set rsh [buildFullEntrybox $dbox_top.a.rsh 17 \
                        "RSH command" 30 "" "right" 0]
  set rshFrame [lindex $rsh 0]
  set rshEntry [lindex $rsh 2]
  $rshEntry configure -textvariable RSH

  frame $dbox_top.a.secs
  set spinBox [buildSpinbox $dbox_top.a.secs 4 1-9999 timeout_secs "" \
        "wait timeout secs: " left ""]
  set secsFrame  [lindex $spinBox 0]
  set secsEntry  [lindex $spinBox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdOk     [lindex $cmdButtons 1]
  set cmdHelp   [lindex $cmdButtons 2]

  $cmdOk configure -command {
     if { [string compare $SERVER_HOSTS ""] == 0 } {
       popupInfoBox $prefDialogBox "Please specify a server host value"
       return
     }
     if { [string compare $timeout_secs ""] == 0 } {
       popupInfoBox $prefDialogBox "Please specify a value for wait timeout secs"
       return
     }
     if { [string compare $XTERM ""] == 0 } {
       popupInfoBox $prefDialogBox "Please specify xterm command"
       return
     }

    destroy $prefDialogBox
  }
  $cmdHelp configure -command {xpbs_help preferences $prefDialogBox}

  register_default_action $serversEntry $cmdOk
  register_default_action $secsEntry $cmdOk
  register_default_action $xtermEntry $cmdOk
  register_default_action $rshEntry $cmdOk
  register_default_action $prefDialogBox $cmdOk

  pack $dbox_top.header $dbox_top.a $dbox_top.footer -padx 5m
  pack $dbox_top.a.main \
       $dbox_top.a.secs \
       $dbox_top.a.xterm \
       $dbox_top.a.rsh -side top -anchor nw -pady 2m

  tkwait visibility $prefDialogBox
  remove_busy_cursor

  catch {tkwait window $prefDialogBox}
  set activeWindow($prefDialogBox) 0
}
